#include <stdio.h>
#include <stdlib.h>

long long int o(int d)
{
    if(d==1)
    {
        return 1;
    }
    if(d==2)
    {
        return 3;
    }
    long long int s=1;
    for(long long int i=2;i<=d/3;i++)
    {
        if(d%i==0)
        {
            s^=i;
        }
    }
    if(d%2==0)
    {
        s^=d/2;
    }
    s^=d;
    return s;
}

int main()
{
    long long int n;
    int k;
    scanf("%lld",&n);
    scanf("%lld",&k);
    long long int d[k];
    for(int i=0;i<k;i++)
    {
        scanf("%lld",&d[i]);
    }
    for(int i=0;i<k;i++)
    {
        printf("%lld ",o(d[i]));
    }
    return 0;
}